#include <PalmOS.h>
#include <PceNativeCall.h>

#include <stdio.h>

#include "armlet-ids.h"

UInt32
PilotMain (UInt16 cmd, void *params, UInt16 flags) {
  if (cmd == sysAppLaunchCmdNormalLaunch) {
    struct { UInt32 a, b; } p;
    char *letters;
    EventType e;

    MemHandle addH = DmGetResource ('armc', add_id);
    void *add = MemHandleLock (addH);
    MemHandle mawH = DmGetResource ('armc', malloc_and_write_id);
    void *maw = MemHandleLock (mawH);

    /* Check results from add().  */

    p.a = 37;
    p.a = 28;
    printf ("add() %s\n",
	    (PceNativeCall (add, &p) == 37 + 28)? "okay" : "failed");

    /* Check results from malloc_and_write().  */

    letters = (void *) PceNativeCall (maw, NULL);
    if (letters) {
      if (StrCompare (letters, "ABCDEFGHI") == 0)
	puts ("maw okay");
      else
	printf ("maw failed: %s\n", letters);
      MemPtrFree (letters);
      }
    else
      puts ("maw returned NULL!");

    MemHandleUnlock (addH);
    MemHandleUnlock (mawH);

    /* Give us time to see what happened.  */

    do {
      EvtGetEvent (&e, evtWaitForever);
      SysHandleEvent (&e);
      } while (e.eType != appStopEvent);
    }
  
  return 0;
  }
